package stracer

import (
	"fmt"
	"runtime"
	"strings"
)

type Type struct {
	T string
	N string
}

func (t Type) String() string {
	if t.Type() == "" {
		return t.Name()
	}

	return fmt.Sprintf("%s - %s", t.T, t.N)
}

func (t Type) Type() string {
	return t.T
}

func (t Type) Name() string {
	return t.N
}

// WithType returns a Type, used for stacktrace (autogenerated name of span) with a subject
func WithType(subject string) Type {
	return Type{
		T: typeOverride(subject),
		N: traceName(1),
	}
}

// WithCustomType returns a Type, which name is a usage of subject
// example: subject: DB, usage: select * from users
func WithCustomType(subject, usage string) Type {
	return Type{
		T: typeOverride(subject),
		N: usage,
	}
}

func traceName(skip int) string {
	pc, _, _, ok := runtime.Caller(skip + 1)
	if !ok {
		return "unknown"
	}

	// It contains full path of pkg, caller and func
	details := runtime.FuncForPC(pc)

	functionFullNameS := strings.Split(details.Name(), "/")

	functionFullName := functionFullNameS[len(functionFullNameS)-1]

	functionFullName = strings.ReplaceAll(functionFullName, ".", "/")
	functionFullName = strings.ReplaceAll(functionFullName, "(", "")
	functionFullName = strings.ReplaceAll(functionFullName, ")", "")
	functionFullName = strings.ReplaceAll(functionFullName, "*", "")

	return functionFullName
}
